package org.simantics.scl.compiler.tests.completions;

import org.junit.Assert;
import org.junit.Test;
import org.simantics.scl.compiler.completions.PrefixUtil;


public class TestPrefixUtil {
    @Test
    public void testFindPrefix() {
        Assert.assertEquals("aaa", PrefixUtil.findPrefix("aaa aaab bbb", 7));
        Assert.assertEquals("aaa.aaa", PrefixUtil.findPrefix("aaa.aaab bbb", 7));
        Assert.assertEquals("a3a.a3a", PrefixUtil.findPrefix("a3a.a3ab bbb", 7));
        Assert.assertEquals("aaa", PrefixUtil.findPrefix("aa .aaab bbb", 7));
    }
    
    @Test
    public void testSplitPrefix() {
        Assert.assertArrayEquals(new String[] {"aa", "bb", "cc"}, PrefixUtil.splitPrefix("aa.bb.cc"));
        Assert.assertArrayEquals(new String[] {"aa", "bb", ""}, PrefixUtil.splitPrefix("aa.bb."));
    }
}
